.586
.model flat, stdcall
option scoped
option casemap:none

	include windows.inc
	include kernel32.inc
	include ole32.inc
	include user32.inc

	include ddtypes.inc
	includelib ole32.lib
	includelib kernel32.lib
	includelib user32.lib

	WinMain		PROTO :DWORD,:DWORD,:DWORD,:DWORD
	MainWndProc	PROTO :DWORD,:DWORD,:DWORD,:DWORD
	InitDDraw	PROTO
	ShutDownDDraw	PROTO
	
; 

.data
	CLSID_DirectDraw	GUID {0D7B70EE0h,04340h,011CFh,{0B0h,063h,000h,020h,0AFh,0C2h,0CDh,035h}}
	IID_IDirectDraw		GUID {06C14DB80h,0A733h,011CEh,{0A5h,021h,000h,020h,0AFh,00Bh,0E5h,060h}}

	CLSID_DirectDraw7	GUID {03c305196h,050dbh,011d3h,{09ch,0feh,000h,0c0h,04fh,0d9h,030h,0c5h}}
	IID_IDirectDraw7	GUID {015e65ec0h,03b9ch,011d2h,{0b9h,02fh,000h,060h,097h,097h,0eah,05bh}}

	lpDD		dd ?
	hMainWnd	dd ?
	CommandLine	dd ?
	hInstance	dd ?
	szMainName	db 'DirectDraw Sample',0
	szText		db 64 dup (0)
	szFormat	db '%s (%X)',0
	szError1	db 'CoCreateInstance failed!',0
	szError2	db 'Initialize failed!',0
	szError3	db 'SetCooperativeLevel failed!',0
	szError4	db 'SetDisplayMode failed!',0
	szErrorCaption	db 'Error!',0
	szMsgCaption	db 'Message',0
	szMsgAllOk	db 'All ok.',0
	dwBitsPerPixel	dd 8
	dwHeight	dd 480
	dwWidht		dd 640
	szMainClassName	db 'MainWindowClass',0

; 

.code
Start:
	invoke	CoInitialize,NULL

	invoke GetModuleHandle,NULL
	mov     hInstance,eax
	invoke GetCommandLine
	mov     CommandLine,eax

	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
@Exit:
	invoke	ExitProcess, 0


; 
; WinMain
; 
WinMain		PROC hInst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

;  variables 
LOCAL wc:WNDCLASSEX
LOCAL msg1:MSG
LOCAL Wwd:DWORD
LOCAL Wht:DWORD
LOCAL Wtx:DWORD
LOCAL Wty:DWORD

;  Fill WNDCLASSEX structure with required variables 
		mov	wc.cbSize,sizeof WNDCLASSEX
		mov	wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
		mov	wc.lpfnWndProc,offset MainWndProc
		mov	wc.cbClsExtra,NULL
		mov	wc.cbWndExtra,NULL
		push	hInst
		pop	wc.hInstance
		mov	wc.hbrBackground,COLOR_WINDOW
		mov	wc.lpszMenuName,NULL
		mov	wc.lpszClassName,offset szMainClassName
		invoke LoadIcon,NULL,IDI_APPLICATION
		mov	wc.hIcon,eax
		invoke LoadCursor,NULL,IDC_ARROW
		mov	wc.hCursor,eax
		mov	wc.hIconSm,0

		invoke RegisterClassEx,ADDR wc

;  Create the main application window 
		invoke CreateWindowEx,NULL,
			offset szMainClassName,
			offset szMainName,
			WS_POPUP,
			0,0,640,480,
			NULL,NULL,
			hInst,NULL
		or	eax,eax
		jz ExitLoop
		mov	hMainWnd,eax

		invoke SetFocus,hMainWnd

; Initialize DDraw 

		invoke InitDDraw
		or	eax,eax
		jnz @Error
		
		invoke MessageBox,hMainWnd,offset szMsgAllOk,offset szMsgCaption,MB_OK

		invoke ShowCursor,FALSE

		invoke SendMessage,hMainWnd,WM_CLOSE,NULL,NULL
		

;  Loop until PostQuitMessage is sent 
StartLoop:
		invoke GetMessage,ADDR msg1,NULL,0,0
		or	eax,eax
		jz ExitLoop
		invoke TranslateMessage,ADDR msg1
		invoke DispatchMessage,ADDR msg1
		jmp StartLoop
ExitLoop:
		mov	eax,msg1.wParam
@End:
		ret

; 

@Error:
		invoke wsprintf,offset szText,offset szFormat,edx,eax
		invoke MessageBox,NULL,offset szText,offset szErrorCaption,MB_OK
		jmp @End

WinMain		ENDP

; 
; Main window procedure
; 
MainWndProc	PROC hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

		mov	 eax,uMsg
; WM_CREATE 
		cmp	eax,WM_CREATE
		jz @Default
; WM_CLOSE 
@WM_CLOSE:
		cmp	eax,WM_CLOSE
		jnz @WM_DESTROY
			invoke DestroyWindow,hMainWnd
			xor	eax,eax
			jmp @End

; WM_DESTROY 
@WM_DESTROY:
		cmp	eax,WM_DESTROY
		jnz @Default
@Quit:
			invoke ShutDownDDraw
			invoke PostQuitMessage,NULL
			xor	eax,eax
			jmp @End

; Default 
@Default:
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam

@End:
		ret
; Output error 
@Error:
		invoke wsprintf,offset szText,offset szFormat,edx,eax
		invoke MessageBox,NULL,offset szText,offset szErrorCaption,MB_OK
		jmp @Quit

MainWndProc	ENDP


; 
; Initialize DirectDraw
; 
InitDDraw	PROC

		invoke 	CoCreateInstance,offset CLSID_DirectDraw,NULL,CLSCTX_ALL,offset IID_IDirectDraw,offset lpDD
		mov	edx,offset szError1
		cmp	eax,S_OK
		jnz @End
	; Initialize
		coinvoke lpDD,IDirectDraw,Initialize,NULL	; offset IID_IDirectDraw
		mov	edx,offset szError2
		cmp	eax,DD_OK
		jnz @End
	; SetCooperativeLevel
		coinvoke lpDD,IDirectDraw,SetCooperativeLevel,hMainWnd,DDSCL_ALLOWMODEX or DDSCL_FULLSCREEN or DDSCL_EXCLUSIVE or DDSCL_ALLOWREBOOT
		mov	edx,offset szError3
		cmp	eax,DD_OK
		jnz @End
		xor	eax,eax
	; SetDisplayMode
		; coinvoke lpDD,IDirectDraw,SetDisplayMode,dwWidth,dwHeight,dwBitsPerPixel
		; mov	edx,offset szError4
		; cmp	eax,DD_OK
		; jnz @End
		; xor	eax,eax
 @End:
		ret
InitDDraw	ENDP

; 
; Shut down DirectDraw
; 
ShutDownDDraw	PROC

		coinvoke lpDD,IDirectDraw,Release
		invoke CoUninitialize
		ret

ShutDownDDraw	ENDP

END Start
